﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using StudentsBusiness;

namespace StudentManagementStudio
{
    public partial class StudentManager : Form
    {
        private StudentMapper _mapper = new StudentMapper();
        private List<Student> _students = new List<Student>();

        public StudentManager()
        {
            InitializeComponent();
            load();
        }

        private void resetButton_Click(object sender, EventArgs e)
        {
            //if you want...
            //idInputTextBox.Clear();
            //nameInputTextBox.Clear();
            load();            
        }

        private void load()
        {
            _students = _mapper.getAllStudents();
            studentsDataGridView.DataSource = _students;                    
        }

        private void nameSearchButton_Click(object sender, EventArgs e)
        {
            _students = _mapper.getStudentByName(nameInputTextBox.Text);
            studentsDataGridView.DataSource = _students;
        }

        private void idSearchButton_Click(object sender, EventArgs e)
        {
            int searchID;
            if (int.TryParse(idInputTextBox.Text, out searchID))
            {
                studentsDataGridView.DataSource = null;

                _students = new List<Student>();
                _students.Add(_mapper.getStudentByID(int.Parse(idInputTextBox.Text)));

                if (_students.ElementAt(0) != null)
                {
                    studentsDataGridView.DataSource = _students;
                }
            }
        }

        private void editRecordButton_Click(object sender, EventArgs e)
        {
            if (studentsDataGridView.Rows.Count > 0)
            {
                //MessageBox.Show("Editing record " + _questions.ElementAt(testQuestionsDataGridView.SelectedRows[0].Index).TestQuestionID);
                EditStudent es = new EditStudent(_students.ElementAt(studentsDataGridView.SelectedRows[0].Index));
                es.ShowDialog();
                load();
            }            
        }

        private void deleteRecordButton_Click(object sender, EventArgs e)
        {
            if (studentsDataGridView.Rows.Count > 0)
            {
                //MessageBox.Show("Deleting record " + _questions.ElementAt(testQuestionsDataGridView.SelectedRows[0].Index).TestQuestionID);
                DeleteStudent ds = new DeleteStudent(_students.ElementAt(studentsDataGridView.SelectedRows[0].Index));
                ds.ShowDialog();
                load();
            }
        }

        private void newRecordButton_Click(object sender, EventArgs e)
        {
            //MessageBox.Show("New record!");
            NewStudent ns = new NewStudent();
            ns.ShowDialog();
            load();
        }
    }
}
