﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using StudentsBusiness;

namespace TestDriver
{
    public partial class Form1 : Form
    {
        private StudentMapper _mapper = new StudentMapper();
        private List<Student> _students = new List<Student>();

        public Form1()
        {
            InitializeComponent();
            fetchData();
        }

        private void fetchData()
        {
            _students = _mapper.getAllStudents();
            dataGridView.DataSource = _students;
        }

        private void getByIDButton_Click(object sender, EventArgs e)
        {
            string idIn = "1";
            int searchID;
            if (int.TryParse(idIn, out searchID))
            {
                dataGridView.DataSource = null;

                _students = new List<Student>();
                _students.Add(_mapper.getStudentByID(int.Parse(idIn)));

                if (_students.ElementAt(0) != null)
                {
                    dataGridView.DataSource = _students;
                }
            }
        }

        private void getByNameButton_Click(object sender, EventArgs e)
        {
            _students = _mapper.getStudentByName("Brian");
            dataGridView.DataSource = _students;
        }

        private void insertStudentButton_Click(object sender, EventArgs e)
        {
            MessageBox.Show("HELLO!");
            Student newStudent = new Student();

            newStudent.StudentName = "Bob Edit Me";
            newStudent.Class1 = "INCLASS";
            newStudent.Status = "BOGUS";
            newStudent.EnteredDate = DateTime.Today;
            newStudent.Ranking = 0;

            MessageBox.Show(_mapper.insertStudent(newStudent));
            fetchData();
        }

        private void updateStudentButton_Click(object sender, EventArgs e)
        {
            Student updateStudent = _students.ElementAt(_students.Count - 1);
            updateStudent.StudentName = "Bob Delete Me";
            updateStudent.Class1 = "GOINOUTTACLASS";
            updateStudent.Status = "EXPIRED";
            updateStudent.EnteredDate = DateTime.Today.AddDays(-1);//back up a day
            updateStudent.Ranking = -1;

            MessageBox.Show(_mapper.updateStudent(updateStudent));
            fetchData();
        }

        private void deleteStudentButton_Click(object sender, EventArgs e)
        {
            Student deleteStudent = _students.ElementAt(_students.Count - 1);

            MessageBox.Show(_mapper.deleteStudent((int)deleteStudent.StudentID));
            fetchData();
        }
    }
}
